package src;

public class SnakeBot extends Bot {
    int stepCounter = 0;
    int turnCount = 0;
    int viewRange = 5;
    int straightLength = 1;
    boolean isOnPath = true;

    protected SnakeBot(String[] args) {
        super(args);
    }

    public static void main(String[] args) {
        SnakeBot bot = new SnakeBot(args);
        bot.run();
    }

    @Override
    protected char nextMove(View view) throws Exception {

        if (!view.data.contains("@") && isOnPath) {

            if (turnCount == 2) {
                turnCount = 0;
                straightLength++;
            }
            if (stepCounter < straightLength * viewRange) {
                stepCounter++;
                return '^';
            } else {
                stepCounter = 0;
                turnCount++;
                return '>';
            }
        } else if (!view.data.contains("@") && !isOnPath) {

        } else {
            isOnPath = false;
            //check for minerals to the left of the rover (high prio)
            for (int i = 0; i < view.data.length(); i += viewRange) {
                if (view.data.substring(i, i + 2).contains("@")) {
                    return '<';
                }
            }
            //check for minerals in front of the rover (mid prio)
            if (view.data.substring(0, view.data.length() / 2 - viewRange / 2).contains("@")) {
                    return '^';
            }
            //check for minerals to the right of the rover (low prio)
            for (int i = 3; i < view.data.length(); i += viewRange) {
                if (view.data.substring(i, i + 2).contains("@")) {
                    return '>';
                }
            }

//            if (view.data.substring(0, 10).contains("@")) {
//                return '^';
//            } else if (view.data.substring(10, 12).contains("@")) {
//                return '<';
//            } else if (view.data.substring(13, 15).contains("@")) {
//                return '>';
//            } else if (view.data.substring(15, 25).contains("@")) {
//                return 'v';
//            }
        }

        return 0;
    }
}
